"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/router.ts
var router_exports = {};
__export(router_exports, {
  Router: () => Router
});
module.exports = __toCommonJS(router_exports);
var import_zhin = require("zhin");
var import_ws = require("ws");
var import_url = require("url");
var KoaRouter = require("@koa/router");
var Router = class extends KoaRouter {
  //用于historyApi排除
  constructor(server, options) {
    super(options);
    this.server = server;
    this.wsStack = [];
    this.whiteList = [];
  }
  register(...args) {
    const path = args[0];
    this.whiteList.push(path);
    return super.register(...args);
  }
  destroy(layer) {
    (0, import_zhin.remove)(this.stack, layer);
  }
  destroyWs(wsServer) {
    wsServer.close();
    (0, import_zhin.remove)(this.wsStack, wsServer);
  }
  ws(path, options = {}) {
    const wsServer = new import_ws.WebSocketServer({
      noServer: true,
      path,
      ...options
    });
    this.wsStack.push(wsServer);
    this.server.on("upgrade", (request, socket, head) => {
      const { pathname } = (0, import_url.parse)(request.url);
      if (this.wsStack.findIndex((wss) => wss.options.path === path) === -1) {
        socket.destroy();
      } else if (pathname === path) {
        wsServer.handleUpgrade(request, socket, head, (ws) => {
          wsServer.emit("connection", ws, request);
        });
      }
    });
    return wsServer;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Router
});
